(** OpenAL buffer management *)

(** Abstract type for OpenAL buffers *)
type t

(** [load_from_file file_name] performs direct loading from file *)
external load_from_file : string -> t = "al_buffer_load_from_file"

external load_from_string : frequency:int -> channels:int -> bits:int ->
  data:string -> t = "al_buffer_load_from_string"

(** alGetBufferi wrapper *)
external geti : t -> [< `frequency
                     |  `bits
                     |  `channels
                     |  `size] -> int = "al_buffer_geti"

(** buffer duration in seconds *)
let duration b =
  float_of_int (geti b `size) /.
    float_of_int (geti b `frequency * geti b `channels * geti b `bits / 8)
